Attribute VB_Name = "modOutput"
Option Explicit

Public Sub CreateBMS(ByRef strOutputPath As String, Optional ByVal Flag As Integer)
On Error GoTo Err:

    Dim strObjData()    As String
    Dim blnObjData()    As Boolean
    Dim i               As Long
    Dim j               As Long
    Dim k               As Long
    Dim lngFFile        As Long
    Dim intBPMNum       As Integer
    Dim intSTOPNum      As Integer
    Dim lngMaxMeasure   As Long
    Dim lngTemp         As Long
    Dim strTemp         As String
    Dim intArray()      As Integer
    Dim lngStop(MATERIAL_MAX)   As Long
    Dim sngBPM(MATERIAL_MAX)    As Single
    
    If Flag = 0 Then frmMain.Caption = g_strAppTitle & " - Now Saving..."
    
    frmMain.Enabled = False
    
    For i = 0 To MATERIAL_MAX
    
        sngBPM(i) = 0
        lngStop(i) = 0
    
    Next i
    
    'IuWF
    For i = 0 To UBound(g_Obj) - 1
    
        With g_Obj(i)
        
            If .intCh Then
            
                If lngMaxMeasure < .intMeasure Then
                    
                    lngMaxMeasure = .intMeasure
                
                End If
                
                Select Case .intCh
                
                    Case CH_EXBPM
                
                        If .sngValue > 0 And .sngValue < 256 And .sngValue = CLng(.sngValue) Then
                        
                            .intCh = CH_BPM
                        
                        Else
                        
                            If intBPMNum > MATERIAL_MAX Then
                            
                                Call MsgBox(g_Message(ERR_OVERFLOW_BPM) & vbCrLf & g_Message(ERR_SAVE_CANCEL), vbCritical, g_strAppTitle)
                                
                                lngTemp = i - 1
                                
                                GoTo Init:
                            
                            End If
                            
                            intBPMNum = intBPMNum + 1
                            sngBPM(intBPMNum) = .sngValue
                            .sngValue = intBPMNum
                        
                        End If
                
                    Case CH_STOP
                
                        If intSTOPNum > MATERIAL_MAX Then
                        
                            Call MsgBox(g_Message(ERR_OVERFLOW_STOP) & vbCrLf & g_Message(ERR_SAVE_CANCEL), vbCritical, g_strAppTitle)
                            
                            lngTemp = i - 1
                            
                            GoTo Init:
                        
                        End If
                        
                        intSTOPNum = intSTOPNum + 1
                        lngStop(intSTOPNum) = .sngValue
                        .sngValue = intSTOPNum
                    
                    Case 11 To 29
                    
                        If .intAtt = OBJ_INVISIBLE Then
                        
                            .intCh = .intCh + 20
                        
                        ElseIf .intAtt = OBJ_LONGNOTE Then
                        
                            .intCh = .intCh + 40
                        
                        End If
                
                End Select
            
            End If
        
        End With
    
    Next i
    
    ReDim strObjData(3 To 132, lngMaxMeasure)
    ReDim blnObjData(3 To 132, lngMaxMeasure)
    
    For i = 0 To lngMaxMeasure
    
        For j = LBound(strObjData, 1) To UBound(strObjData, 1)
        
            strObjData(j, i) = String$(g_Measure(i).intLen * 2, "0")
        
        Next j
    
    Next i
    
    'IuWF烉Cf[^ɕϊ
    For i = 0 To UBound(g_Obj) - 1
    
        With g_Obj(i)
        
            Select Case .intCh
            
                Case Is < 0
                
                Case Is > 1000
                
                Case Is > 100
                
                    strObjData(.intCh, .intMeasure) = left$(strObjData(.intCh, .intMeasure), .lngPosition * 2) & _
                        modInput.strFromNum(.sngValue) & Mid$(strObjData(.intCh, .intMeasure), .lngPosition * 2 + 3)
                    
                    For j = 101 To .intCh - 1
                    
                        blnObjData(j, .intMeasure) = True
                    
                    Next j
                
                Case CH_BPM
                
                    strObjData(.intCh, .intMeasure) = left$(strObjData(.intCh, .intMeasure), .lngPosition * 2) & _
                        right$("0" & Hex$(.sngValue), 2) & Mid$(strObjData(.intCh, .intMeasure), .lngPosition * 2 + 3)
                
                Case CH_EXBPM
                
                    strObjData(.intCh, .intMeasure) = left$(strObjData(.intCh, .intMeasure), .lngPosition * 2) & _
                        right$("0" & IIf(intBPMNum > 255, modInput.strFromNum(.sngValue), Hex$(.sngValue)), 2) & _
                        Mid$(strObjData(.intCh, .intMeasure), .lngPosition * 2 + 3)
                
                Case CH_STOP
                
                    strObjData(.intCh, .intMeasure) = left$(strObjData(.intCh, .intMeasure), .lngPosition * 2) & _
                        right$("0" & IIf(intSTOPNum > 255, modInput.strFromNum(.sngValue), Hex$(.sngValue)), 2) & _
                        Mid$(strObjData(.intCh, .intMeasure), .lngPosition * 2 + 3)
                
                Case Else
                
                    strObjData(.intCh, .intMeasure) = left$(strObjData(.intCh, .intMeasure), _
                        .lngPosition * 2) & modInput.strFromNum(.sngValue) & Mid$(strObjData(.intCh, .intMeasure), .lngPosition * 2 + 3)
                
            End Select
            
            blnObjData(.intCh, .intMeasure) = True
        
        End With
    
    Next i
    
    For i = LBound(strObjData, 2) To UBound(strObjData, 2)
    
        For j = LBound(strObjData, 1) To UBound(strObjData, 1)
        
            If blnObjData(j, i) Then
            
                If strObjData(j, i) <> "00" Then
                
                    ReDim intArray(g_Measure(i).intLen + 1)
                    
                    intArray(0) = g_Measure(i).intLen
                    strTemp = ""
                    lngTemp = 1
                    
                    For k = 1 To Len(strObjData(j, i)) \ 2
                    
                        If Mid$(strObjData(j, i), k * 2 - 1, 2) = "00" Then
                        
                            strTemp = strTemp & "0"
                        
                        Else
                        
                            intArray(lngTemp) = Len(strTemp)
                            lngTemp = lngTemp + 1
                            strTemp = "1"
                        
                        End If
                    
                    Next k
                    
                    ReDim Preserve intArray(lngTemp)
                    
                    intArray(lngTemp) = Len(strTemp)
                    
                    lngTemp = intGetMaxDev(intArray)
                    
                    If lngTemp Then
                    
                        strTemp = ""
                        
                        For k = 1 To Len(strObjData(j, i)) \ 2 Step lngTemp
                        
                            strTemp = strTemp & Mid$(strObjData(j, i), k * 2 - 1, 2)
                        
                        Next k
                        
                        strObjData(j, i) = strTemp
                    
                    End If
                
                End If
                
            End If
        
        Next j
    
    Next i
    
    lngFFile = FreeFile()
    
    'o͊Jn
    Open strOutputPath For Output As #lngFFile
    
        With frmMain
        
            Print #lngFFile,
            Print #lngFFile, "*---------------------- HEADER FIELD"
            Print #lngFFile,
            'If Flag Then Print #lngFFile, "#PATH_WAV " & g_BMS.strDir
            
            If .cboPlayer.ListIndex > 1 Then
            
                Print #lngFFile, "#PLAYER 3"
            
            Else
            
                Print #lngFFile, "#PLAYER " & .cboPlayer.ListIndex + 1
            
            End If
            
            Print #lngFFile, "#GENRE " & Trim$(.txtGenre.Text)
            Print #lngFFile, "#TITLE " & Trim$(.txtTitle.Text)
            Print #lngFFile, "#ARTIST " & Trim$(.txtArtist.Text)
            Print #lngFFile, "#BPM " & Trim$(.txtBPM.Text)
            Print #lngFFile, "#PLAYLEVEL " & Trim$(.cboPlayLevel)
            Print #lngFFile, "#RANK " & .cboPlayRank.ListIndex
            
            If Val(.txtTotal.Text) Then Print #lngFFile, "#TOTAL " & .txtTotal.Text
            
            If Val(.txtVolume.Text) Then Print #lngFFile, "#VOLWAV " & .txtVolume.Text
            
            Print #lngFFile, "#STAGEFILE " & Trim$(.txtStageFile.Text)
            Print #lngFFile,
            
            For i = 1 To 1295
            
                If Len(g_strWAV(i)) Then
                
                    Print #lngFFile, "#WAV" & modInput.strFromNum(i) & " " & g_strWAV(i)
                
                End If
            
            Next i
            
            Print #lngFFile,
            
            If Len(Trim$(.txtMissBMP.Text)) Then
            
                Print #lngFFile, "#BMP00 " & .txtMissBMP.Text
            
            End If
            
            For i = 1 To 1295
            
                If Len(g_strBMP(i)) Then
                
                    Print #lngFFile, "#BMP" & modInput.strFromNum(i) & " " & g_strBMP(i)
                
                End If
            
            Next i
            
            Print #lngFFile,
            
            For i = 1 To 1295
            
                If Len(g_strBGA(i)) Then
                
                    Print #lngFFile, "#BGA" & modInput.strFromNum(i) & " " & g_strBGA(i)
                
                End If
            
            Next i
            
            Print #lngFFile,
            
            If intBPMNum > 255 Then
            
                For i = 1 To 1295
                
                    If sngBPM(i) Then
                    
                        Print #lngFFile, "#BPM" & right$("0" & modInput.strFromNum(i), 2) & " " & sngBPM(i)
                    
                    End If
                
                Next i
            
            ElseIf intBPMNum Then
            
                For i = 1 To 255
                
                    If sngBPM(i) Then
                    
                        Print #lngFFile, "#BPM" & right$("0" & Hex$(i), 2) & " " & sngBPM(i)
                    
                    End If
                
                Next i
            
            End If
            
            Print #lngFFile,
            
            If intSTOPNum > 255 Then
            
                For i = 1 To MATERIAL_MAX
                
                    If lngStop(i) Then
                    
                        Print #lngFFile, "#STOP" & right$("0" & modInput.strFromNum(i), 2) & " " & lngStop(i)
                    
                    End If
                
                Next i
            
            ElseIf intSTOPNum Then
            
                For i = 1 To 255
                
                    If lngStop(i) Then
                    
                        Print #lngFFile, "#STOP" & right$("0" & Hex$(i), 2) & " " & lngStop(i)
                    
                    End If
                
                Next i
            
            End If
            
            Print #lngFFile,
            
            Print #lngFFile, .txtExInfo.Text
            
            Print #lngFFile,
        
        End With
        
        Print #lngFFile,
        Print #lngFFile, "*---------------------- MAIN DATA FIELD"
        Print #lngFFile,
        
        For i = 0 To UBound(blnObjData, 2)
        
            For j = 101 To 132
            
                If blnObjData(j, i) Then
                
                    Print #lngFFile, "#" & Format$(i, "000") & "01" & ":" & strObjData(j, i)
                
                End If
            
            Next j
            
            With g_Measure(i)
                
                If .intLen <> MEASURE_LENGTH Then
                
                    Print #lngFFile, "#" & Format$(i, "000") & "02:" & .intLen / MEASURE_LENGTH
                
                End If
            
            End With
            
            For j = 3 To 99
            
                If blnObjData(j, i) Then
                
                    Print #lngFFile, "#" & Format$(i, "000") & Format$(j, "00") & ":" & strObjData(j, i)
                
                End If
            
            Next j
            
            Print #lngFFile,
        
        Next i
        
        lngTemp = UBound(blnObjData, 2) + 1
        
        For i = lngTemp To 999
        
            With g_Measure(i)
                
                If .intLen <> MEASURE_LENGTH Then
                
                    Print #lngFFile, "#" & Format$(i, "000") & "02:" & .intLen / MEASURE_LENGTH
                
                End If
            
            End With
        
        Next i
    
    lngTemp = UBound(g_Obj) - 1
    
    With g_BMS
    
        .intPlayerType = frmMain.cboPlayer.ListIndex + 1
        .strGenre = frmMain.txtGenre.Text
        .strTitle = frmMain.txtTitle.Text
        .strArtist = frmMain.txtArtist.Text
        .lngPlayLevel = Val(frmMain.cboPlayLevel.Text)
        .sngBPM = Val(frmMain.txtBPM.Text)
        
        .intPlayRank = frmMain.cboPlayRank.ListIndex
        .sngTotal = Val(frmMain.txtTotal.Text)
        .intVolume = Val(frmMain.txtVolume.Text)
        .strStageFile = frmMain.txtStageFile.Text
    
    End With
    
Init:

    Close #lngFFile
    
    For i = 0 To lngTemp
    
        With g_Obj(i)
        
            Select Case .intCh
            
                Case CH_BPM
                
                    .intCh = CH_EXBPM
                
                Case CH_EXBPM
                
                    .sngValue = sngBPM(.sngValue)
                
                Case CH_STOP
                
                    .sngValue = lngStop(.sngValue)
                
                Case 31 To 49
                
                    .intCh = .intCh - 20
                
                Case 51 To 69
                
                    .intCh = .intCh - 40
            
            End Select
        
        End With
    
    Next i
    
    frmMain.Enabled = True
    
    If Flag = 0 Then
    
        g_BMS.blnSaveFlag = True
        
        If Len(g_BMS.strDir) Then
        
            If frmMain.mnuOptionsItem(TITLE_FILENAME).Checked Then
            
                frmMain.Caption = g_strAppTitle & " - " & g_BMS.strFileName
            
            Else
            
                frmMain.Caption = g_strAppTitle & " - " & g_BMS.strDir & g_BMS.strFileName
            
            End If
        
        End If
    
    End If
    
    Exit Sub

Err:
    Call MsgBox(g_Message(ERR_SAVE_ERROR) & vbCrLf & g_Message(ERR_SAVE_CANCEL) & vbCrLf & "Error No." & Err.Number & " " & Err.Description, vbCritical, g_strAppTitle)
    frmMain.Enabled = True
    frmMain.Caption = g_strAppTitle & " - " & g_BMS.strDir & g_BMS.strFileName
End Sub

Private Function intGetMaxDev(ByRef BaseValue() As Integer) As Integer

    Dim Count As Long        'z̍őCfbNX
    Dim i As Long            'JE^
    Dim a As Long, b As Long 'ő񐔂߂2̗vf
    
    Count = UBound(BaseValue)
    a = BaseValue(0)

    'JԂ񐔂́A(z̐|1)
    For i = 1 To Count
    
        b = BaseValue(i)
        
        If b Then
        
            Do While a <> b
            
                If a > b Then
                
                    a = a - b
                
                Else
                
                    b = b - a
                
                End If
            
            Loop
            
            '1œꍇAő񐔂͂Ȃ
            If a = 1& Then intGetMaxDev = 0&: Exit Function
        
        End If
    
    Next i
    
    'ő񐔂Ԃ
    intGetMaxDev = a

End Function
